/**
 * CSCI 201 - Homework 5
 * 
 * @author [add your name here]
 */

public class TriMergeSorter {
  
  /**
   * Sorts an array of items using tri-merge-sort.
   */
  public static void sort(int[] items) {
    triMergeSortHelper(items, 0, items.length);
  }

  /**
   * Determines the minimum of (items[i], items[j], items[k]), 
   * encoding the result described by the @return description below.
   * 
   * @param items - entire array of items.
   * @param i - index of the 1st item being considered.
   * @param j - index of the 2nd item being considered.
   * @param k - index of the 3rd item being considered.
   * @return < 0 if items[i] is the minimum,
   *         = 0 if items[j] is the minimum,
   *         > 0 if items[k] is the minimum.
   */
  public static int compare(int[] items, int i, int j, int k) {
    // TODO complete this method and replace placeholder (0) below.
    return 0;
  }

  /**
   * Runs tri-merge-sort on a portion of the items, starting
   * at the "left" item, up to (but not including) the "right" item.
   * 
   * @param items - entire array to be sorted.
   * @param left  - first index of the subarray to be sorted.
   * @param right - 1 + the last index of the subarray to be sorted.
   */
  private static void triMergeSortHelper(int[] items, int left, int right) {
    int n = right - left;
    if (n <= 1) {
      return;
    }

    // Calculate the bounds of the three subarrays.
    // The 1st subarray goes from items[left] to (including) items[mid1 - 1].
    // The 2nd subarray goes from items[mid1] to (including) items[mid2 - 1].
    // The 3rd subarray goes from items[mid2] to (including) items[right - 1].
    int mid1 = left + n / 3;
    int mid2 = left + 2 * n / 3;

    // TODO: recursively sort the three subarrays using "triMergeSortHelper"

    // TODO: merge the three subarrays.
  }

  /**
   * Merges the sorted subarrays items[left:mid1], items[mid1:mid2], items[mid2:right]
   * into items[left:right] so that items[left:right] is sorted.
   * 
   * @param items - the entire array being sorted.
   * @param left  - index of the 1st element in the leftmost subarray.
   * @param mid1  - index of the 1st element in the middle subarray.
   * @param mid2  - index of the 1st element in the rightmost subarray. 
   * @param right - 1 + the index of the last element in the rightmost subarray.
   */
  public static void merge(int[] items, int left, int mid1, int mid2, int right) {
    // Empty one of the subarrays.
    int i1 = left;
    int i2 = mid1;
    int i3 = mid2;
    int[] merged = new int[right - left];
    int j = 0;
    while (i1 < mid1 && i2 < mid2 && i3 < right) {
      int result = compare(items, i1, i2, i3);
      if (result < 0) {
        merged[j] = items[i1++];
      } else if (result == 0) {
        merged[j] = items[i2++];
      } else {
        merged[j] = items[i3++];
      }
      j++;
    }

    // TODO: Empty one of the other two subarrays.

    // TODO: Empty the final subarray.

    // TODO: Save the result in "merged" back into the "items" array.
  }

  // TODO create public static void main for testing.
}
